
class GenericParser:

    def __init__(self, data, encoding):
        pass

    def getDirectChildrenWithName(self, parent, name):
        raise NoImplementedError()

    def finish(self):
        pass

    def getChildren(self, tree):
        raise NoImplementedError()

    def getNodeType(self, node):
        raise NoImplementedError()

    def getNodeValue(self, node):
        raise NoImplementedError()

    def getNodeName(self, node):
        raise NoImplementedError()

    def getValueForAttribute(self, node, attrName):
        raise NoImplementedError()

    def isTextNode(self, node):
        raise NoImplementedError()

    def isChild(self, node, parentNodeName, tree):
        raise NoImplementedError()

    def toXml(self, tree):
        raise NoImplementedError()

    def getComments(self, tree):
        raise NoImplementedError()
            
    def getText(self, tree):
        raise NoImplementedError()

    def getCDATA(self, tree):
        raise NoImplementedError()

    def textNodeName(self):
        raise NoImplementedError()

class ParseError(Exception):
    """ XML Parse Error.

        Raised when XML data cannot be parsed by `XMLObject.fromXml`.
    """

    def __init__(self, domException, xmlData, encoding=None):
        Exception.__init__(self)
        self._domExcp = domException
        self._xmlData = xmlData
        self._encoding = encoding

    def __str__(self):
        if self._encoding:
            return utils.customUnicode(str(self._domExcp),self._encoding) + \
                   u':\n' + utils.customUnicode(str(self._xmlData),self._encoding)
        else:
            return "%s:\n%s" % (self._domExcp, self._xmlData)
