# Copyright (C) 2004 Philippe Normand <phil@base-art.net>
#
# This file is part of EaseXML (http://easexml.base-art.net)
#
# Under PSF License (see COPYING)
# $HeadURL: http://svn.base-art.net/public/easexml/trunk/EaseXML/utils.py $
# $Id: utils.py 108 2005-07-30 13:16:19Z phil $

from types import UnicodeType, NoneType
import sys

def lowWord(word):
    " FoObar -> foObar "
    return word[0].lower() + word[1:]

def titleWord(word):
    " foObar -> FoObar "
    return word[0].upper() + word[1:]


def replaceAll(initialString, translationHash):
    """ for each (toReplace, replacement) in `translationHash`
        applying the query-replace operation to `initialString`
    """
    result = ''
    if initialString is not None:
        result = initialString
        for key, value in translationHash:
            result = result.replace(key, value)
    return result

def contains(list1, list2):
    """ Check if some elements of list1 appear in list2

        Return the intersection of the two lists
    """
    return [ it1 for it1 in list1 if it1 in list2 ]

def customUnicode(data, encoding):
    if type(data) not in (UnicodeType, NoneType):
        if encoding:
            data = unicode(data, encoding)
        else:
            data = unicode(data)
    return data
