import xml_lexing
from transolution.path_mod import path

class Handler(object):
    def __init__(self):
        pass
    def startDocument(self):
        pass
    def endDocument(self):
        pass
    def declaration(self,token):
        pass
##        print "declaration:", token
    def xmlDeclaration(self,token):
        pass
##        print "xml declaration:", token
    def processingInstruction(self,token):
        pass
##        print "processing instruction:", token
    def endTag(self,token):
        pass
##        print "end-tag:", token
    def emptyTag(self,token):
        pass
##        print "empty-tag:", token
    def startTag(self,token):
        pass
##        print "start-tag:", token
    def error(self,token):
        pass
##        print "error:", token
    def text(self,token):
        pass
##        print "text:", token

class TokenParser(object):
    def __init__(self,handler):
        self.handler = handler

    def parse(self,tokens):
        h = self.handler
        self.handler.startDocument()
        for token in tokens:
            if token.startswith("<"):
                if token.startswith("<!"):
                    h.declaration(token)
                elif token.startswith("<?xml"):
                    h.xmlDeclaration(token)
                elif token.startswith("<?"):
                    h.processingInstruction(token)
                elif token.startswith("</"):
                    h.endTag(token)
                elif token.endswith("/>"):
                    h.emptyTag(token)
                elif token.endswith(">"):
                    h.startTag(token)
                else:
                    h.error(token)
            else:
                h.text(token)
        self.handler.endDocument()
