class IndexNode:
    def __init__ (self,parent = None,leaf = True, root = False):
        self.items = []
        self.is_root = root
        self.is_leaf = leaf
        self.parent = parent

class IndexItem:
    def __init__ (self,pointer,data):
        self.pointer = pointer
        self.data = data
        
class VectorIndex:
    def __init__ (self):
        self.root = IndexNode(None,True,True)
        self.scanresult = []
        self.item_count = 0
        self.nodesize = 10
        self.fuzz = 2
        self.rootsplits = 0
        self.intpages = 0
        self.leafpages = 1
        self.keycomps = 0
        self.icomps = 0
    
    def addItem (self,item):
        key = item.pointer
        node = self.root
        self.item_count = self.item_count + 1
        while not node.is_leaf:
            node = self.chooseChildNode(node,item.pointer)
        node.items.append(item)
        if(len(node.items) > self.nodesize):
                self.splitNode(node)
        else:
            self.updatePointers(node)

    def chooseChildNode(self,node,key):
        curchild = node.items[0].data
        cont = len(self.opContainment(key, node.items[0].pointer))
        for item in node.items:
            tmpcont = len(self.opContainment(key, item.pointer))
            if tmpcont < cont:
                curchild = item.data
                cont = tmpcont
        return curchild

    def splitNode(self,node):
        leftitems = []
        rightitems = []
        diff = 0
        if node.is_root:
            self.root = IndexNode(None,False,True)
            node.is_root = False
            node.parent = self.root
            node.parent.items.append(IndexItem(self.getTotalPointer(node.items),node))
            self.rootsplits += 1
            self.intpages += 1
        if node.is_leaf:
            self.leafpages += 1
        else:
            self.intpages += 1
        clitem = node.items[0]
        critem = None
        for item in node.items:
            if id(item) != id(clitem):
                tmpdiff = len(self.opDifference(clitem.pointer,item.pointer))
                if tmpdiff > diff:
                    critem = item
                    diff = tmpdiff
        leftitems.append(clitem)
        leftptr = clitem.pointer
        rightitems.append(critem)
        rightptr = critem.pointer
        for item in node.items:
            if id(item) != id(clitem) and id(item) != id(critem):
                if self.opIntersect(item.pointer,leftptr) > self.opIntersect(item.pointer,rightptr):
                    leftitems.append(item)
                    leftptr = self.opUnion(leftptr,item.pointer)
                else:
                    rightitems.append(item)
                    rightptr = self.opUnion(rightptr,item.pointer)
        node.items = leftitems
        rnode = IndexNode(node.parent,node.is_leaf,False)
        rnode.items = rightitems
        if not node.is_leaf:
            for moved in rightitems:
                moved.data.parent = rnode
        node.parent.items.append(IndexItem(self.getTotalPointer(rnode.items),rnode))
        self.updatePointers(node)
        if(len(node.parent.items) > self.nodesize):
                self.splitNode(node.parent)

    def updatePointers(self,node):
        if not node.is_root:
            key = self.getTotalPointer(node.items)
            for item in node.parent.items:
                if item.data is node:
                    item.pointer = key
                    self.updatePointers(node.parent)

    def findItem(self,key):
        self.scanresult = []
        self.keycomps = 0
        self.icomps = 0
        self.doFindKey(self.root,key)
        result = self.scanresult
        self.scanresult = []
        return result

    def doFindKey(self,node,key):
        if node.is_leaf:
            for item in node.items:
                self.keycomps += 1
                if len(self.opDifference(key,item.pointer)) <= self.fuzz:
                    self.scanresult.append(item.data)
        else:
            for item in node.items:
                self.keycomps += 1
                self.icomps += 1
                if len(self.opContainment(key,item.pointer)) <= self.fuzz:
                    self.doFindKey(item.data,key)

    def opIntersect(self,key1,key2):
        retval = []
        for elem in key1:
            if elem in key2:
                retval.append(elem)
        return retval

    def opUnion(self,key1,key2):
        retval = []
        retval.extend(key1)
        for elem in key2:
            if elem not in key1:
                retval.append(elem)
        return retval

    def opDifference(self,key1,key2):
        i = 0
        j = 0
        ix = len(key1)
        jx = len(key2)
        cond = True
        retval = []
        while cond is True:
            if(key1[i] < key2[j]):
                retval.append(key1[i])
                i += 1
            elif(key1[i] > key2[j]):
                retval.append(key2[j])
                j += 1
            else:
                i += 1
                j += 1
            if j == jx or i == ix:
                cond = False
        if j == jx and i == ix:
            pass
        elif i == ix:
            while j < jx:
                retval.append(key2[j])
                j += 1
        else:
            while i < ix:
                retval.append(key1[i])
                i += 1
        return retval

    def opContainment(self,key1,key2):
        retval = []
        for elem in key1:
            if elem not in key2:
                retval.append(elem)
        return retval

    def getTotalPointer(self,items):
        retval = []
        rettmp = []
        for item in items:
            rettmp.extend(item.pointer)
        rettmp.sort()
        retval.append(rettmp[0])
        for item in rettmp:
            if retval[-1] != item:
                retval.append(item)
        return retval
