#!/usr/bin/env python
import index
import sys

tv1 = [[1,2,3],[2,3,4],[3,4,5],[4,5,6],[1,4,7],[7,8,9]]
tv2 = [[1,2,3,4],[5,6,7,8],[9,10,11,12],[13,14,15,16],[1,5,9,13]]
tv3 = [[1,2,3,4],[5,6,7,8],[9,10,11,12],[13,14,15,16],[17,18,19,20],[21,22,23,24]]

tstidx = index.VectorIndex()
tstidx.nodesize = 4
#testing basic ops in the index
if True:
    #testing opIntersect
    rv = [[1,2,3],[2,3],[3],[],[1],[]]
    fail = False
    for i in range(6):
        val = tstidx.opIntersect(tv1[0],tv1[i])
        val.sort()
        if(val != rv[i]):
            fail = True
        val = tstidx.opIntersect(tv1[i],tv1[0])
        val.sort()
        if( val != rv[i]):
            fail = True
    if fail:
        print "opIntersect - Test 1 - FAIL"
        sys.exit()
    print "opIntersect - Test 1 - PASS"
    
    rv = [[1,2,3],[],[],[],[1]]
    fail = False
    for i in range(5):
        val = tstidx.opIntersect(tv1[0],tv2[i])
        val.sort()
        if(val != rv[i]):
            fail = True
        val = tstidx.opIntersect(tv2[i],tv1[0])
        val.sort()
        if(val != rv[i]):
            fail = True
    if fail:
        print "opIntersect - Test 2 - FAIL"
        sys.exit()
    print "opIntersect - Test 2 - PASS"

if True:
    #testing opUnion
    rv = [[1,2,3],[1,2,3,4],[1,2,3,4,5],[1,2,3,4,5,6],[1,2,3,4,7],[1,2,3,7,8,9]]
    fail = False
    for i in range(6):
        val = tstidx.opUnion(tv1[0],tv1[i])
        val.sort()
        if(val != rv[i]):
            fail = True
        val = tstidx.opUnion(tv1[i],tv1[0])
        val.sort()
        if(val != rv[i]):
            fail = True
    if fail:
        print "opUnion - Test 1 - FAIL"
        sys.exit()
    print "opUnion - Test 1 - PASS"
    rv = [[1,2,3,4],[1,2,3,5,6,7,8],[1,2,3,9,10,11,12],[1,2,3,13,14,15,16],[1,2,3,5,9,13]]
    fail = False
    for i in range(5):
        val = tstidx.opUnion(tv1[0],tv2[i])
        val.sort()
        if(val != rv[i]):
            fail = True
        val = tstidx.opUnion(tv2[i],tv1[0])
        val.sort()
        if(val != rv[i]):
            fail = True
    if fail:
        print "opUnion - Test 2 - FAIL"
        sys.exit()
    print "opUnion - Test 2 - PASS"
if True:
    #testing opDifference
    rv = [[],[1,4],[1,2,4,5],[1,2,3,4,5,6],[2,3,4,7],[1,2,3,7,8,9]]
    fail = False
    for i in range(6):
        val = tstidx.opDifference(tv1[0],tv1[i])
        val.sort()
        if(val != rv[i]):
            fail = True
        val = tstidx.opDifference(tv1[i],tv1[0])
        val.sort()
        if(val != rv[i]):
            fail = True
    if fail:
        print "opDiference - Test 1 - FAIL"
        sys.exit()
    print "opDifference - Test 1 - PASS"
    rv = [[4],[1,2,3,5,6,7,8],[1,2,3,9,10,11,12],[1,2,3,13,14,15,16],[2,3,5,9,13]]
    fail = False
    for i in range(5):
        val = tstidx.opDifference(tv1[0],tv2[i])
        val.sort()
        if(val != rv[i]):
            fail = True
        val = tstidx.opDifference(tv2[i],tv1[0])
        val.sort()
        if(val != rv[i]):
            fail = True
    if fail:
        print "opDiference - Test 2 - FAIL"
        sys.exit()
    print "opDiference - Test 2 - PASS"
if True:
    #testing opContainment
    rv1 = [[],[1],[1,2],[1,2,3],[2,3],[1,2,3]]
    rv2 = [[],[4],[4,5],[4,5,6],[4,7],[7,8,9]]
    fail = False
    for i in range(6):
        val = tstidx.opContainment(tv1[0],tv1[i])
        val.sort()
        if(val != rv1[i]):
            fail = True
        val = tstidx.opContainment(tv1[i],tv1[0])
        val.sort()
        if(val != rv2[i]):
            fail = True
    if fail:
        print "opContainment - Test 1 - FAIL"
        sys.exit()
    print "opContainment - Test 1 - PASS"
    rv1 = [[],[1,2,3],[1,2,3],[1,2,3],[2,3]]
    rv2 = [[4],[5,6,7,8],[9,10,11,12],[13,14,15,16],[5,9,13]]
    fail = False
    for i in range(5):
        val = tstidx.opContainment(tv1[0],tv2[i])
        val.sort()
        if(val != rv1[i]):
            fail = True
        val = tstidx.opContainment(tv2[i],tv1[0])
        val.sort()
        if(val != rv2[i]):
            fail = True
    if fail:
        print "opContainment - Test 2 - FAIL"
        sys.exit()
    print "opContainment - Test 2 - PASS"
if True:
    #testing getTotalPointer
    rv = [1,2,3,4,5,6,7,8,9]
    fail = False
    tst = []
    for i in range(6):
        tst.append(index.IndexItem(tv1[i],None))
    val = tstidx.getTotalPointer(tst)
    if(val != rv):
        fail = True
    if fail:
        print "getTotalPointer - Test 1 - FAIL"
        sys.exit()
    print "getTotalPointer - Test 1 - PASS"
    rv = [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16]
    fail = False
    tst = []
    for i in range(5):
        tst.append(index.IndexItem(tv2[i],None))
    val = tstidx.getTotalPointer(tst)
    if(val != rv):
        fail = True
    if fail:
        print "getTotalPointer - Test 2 - FAIL"
        sys.exit()
    print "getTotalPointer - Test 2 - PASS"

#testing index oerations addItem/splitNode
if True:
    rv = [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24]
    fail = False
    for i in range(6):
        tstidx.addItem(index.IndexItem(tv3[i],None))
    val = tstidx.getTotalPointer(tstidx.root.items)
    if(val != rv):
        fail = True
    if fail:
        print "addItem - Test 1 - FAIL"
        sys.exit()
    print "addItem - Test 1 - PASS"
    
