class poEntry:
    def __init__(self):
        self.xlatComment = []
        self.autoComment = []
        self.refComment = []
        self.procComment = []
        self.msgid = ''
        self.msgstr = ''

ENTRY_START = 0
ENTRY_MSGID = 1
ENTRY_MSGSTR = 2
ENTRY_COMPLETE = 3
    
def getPoEntries(fd):
    state = ENTRY_START
    entry = poEntry()
    for line in fd:
        if line.isspace():
            if state == ENTRY_MSGSTR:
                state = ENTRY_COMPLETE
        elif line[0:2] == u"# ":
            entry.xlatComment.append(line[2:])
        elif line[0:2] == u"#.":
            entry.autoComment.append(line[2:])
        elif line[0:2] == u"#:":
            entry.refComment.append(line[2:])
        elif line[0:2] == u"#,":
            entry.procComment.append(line[2:])
        elif line[0] == u'"':
            epos = line.rfind(u'"')
            if epos == 0:
                text = ''
            else:
                text = line[1:epos]
            if state == ENTRY_MSGID:
                entry.msgid += text
            elif state == ENTRY_MSGSTR:
                entry.msgstr += text
        elif line.startswith(u"msgid"):
            spos = line.find(u'"')
            epos = line.rfind(u'"')
            if epos == spos:
                entry.msgid = u''
            else:
                entry.msgid = line[(spos + 1):epos]
                state = ENTRY_MSGID
        elif line.startswith(u"msgstr"):
            spos = line.find(u'"')
            epos = line.rfind(u'"')
            if epos == spos:
                entry.msgstr = u''
            else:
                entry.msgstr = line[(spos + 1):epos]
                state = ENTRY_MSGSTR
        if state == ENTRY_COMPLETE:
            yield entry
            entry = poEntry()
            state = ENTRY_START
    if state == ENTRY_MSGSTR:
        yield entry
    raise StopIteration
