#!/usr/bin/env python
import transolution.tmx as tmx
import index
import sys
import codecs
import poparse

poenc = "utf-8"
src_lang = u"en"
trg_lang = u"sv-se"

fd = codecs.open(sys.argv[1],"r",poenc)
tm = tmx.getTMXFromFile(sys.argv[2])
tmidx = index.VectorIndex()
tmidx.nodesize = 40
tmidx.fuzz = 0
totents = 0
ents = 0
for tu in tm.body.tus:
    try:
        key = tu.getKey(u'en')
    except IndexError,e:
        continue
    ents += 1
    tmidx.addItem(index.IndexItem(key,tu))
    if ents == 100:
        totents += 100
        ents = 0
        print repr(totents)  + " " + repr(tmidx.rootsplits) + " " + repr(tmidx.intpages) + " " + repr(tmidx.leafpages) + "\n"
totents += ents
print "Total entries: " + repr(totents)
ents = 0
totret = 0
kcomps = 0
icomps = 0
miss = 0
ent = 0
for entry in poparse.getPoEntries(fd):
    if len(entry.msgid) > 0:
        key = []
        rkey = []
        for word in entry.msgid.split():
            key.append(hash(word))
        key.sort()
        try:
            rkey.append(key[0])
        except IndexError,e:
            continue
        for elem in key:
            if rkey[-1] != elem:
                rkey.append(elem)
        tmidx.fuzz = (len(rkey) / 3) + 1
        reslen = len(tmidx.findItem(rkey))
        totret += reslen
        ent += 1
        if reslen == 0:
            print repr(ent) + " Missing"
            miss += 1
        kcomps += tmidx.keycomps
        icomps += tmidx.icomps
        ents += 1
        if ents == 100:
            print repr(totret/100.0) + " " + repr(kcomps/100) + " " + repr(icomps/100)
            totret = 0
            kcomps = 0
            icomps = 0
            ents = 0
print repr(miss)
