__doc__ = 'Formatters for document model segments (external/internal)'
import seg_formatters
from segments import External,TuSegment,FileInfo,TuInfo

class DocumentFormatter(object):
    '''Formats segments in a document
    '''
    def __init__(self):
        self.tu_formatter,self.eformatter,self.bg_colors = None,None,None

    def setBgColors(self,bg_col):
        seg_formatters.bg_colors = bg_col

    def activate(self):
        # Update Class formatters to use
        FileInfo.formatter = self.fformatter
        External.formatter = self.eformatter
        TuSegment.formatter = self.tu_formatter
        TuInfo.formatter = self.tu_info_formatter

    def showSource(self,val):
        self.tu_formatter.show_source = val
        print "Show soruce:",self.tu_formatter.show_source
    def showTarget(self,val):
        self.tu_formatter.show_target = val
    def getShowSource(self):
        return self.tu_formatter.show_source
    def getShowTarget(self):
        return self.tu_formatter.show_target

    def setTagFormatter(self,tagformatter):
        self.tu_formatter.subformatter = tagformatter
    def getTagFormatter(self):
        return self.tu_formatter.subformatter

    def setSkeletonFormatterMode(self,mode):
        self.eformatter.setFormatterMode(mode)

    def getSkeletonFormatterMode(self):
        return self.eformatter.getFormatterMode()
    
    def setSubFormatters(self,tu_formatter,eformatter,fformatter,tu_info_formatter):
        '''tu_formatter - tu segment formatter
           eformatter - formatter to format external segs
        '''
        self.fformatter = fformatter
        self.eformatter = eformatter
        self.tu_formatter = tu_formatter
        self.tu_info_formatter = tu_info_formatter

    def getFormatted(self,seg):
        seg.format()
        return seg.styledtext
    
    def seg2str(self,seg):
        seg.format()
        return seg.data
