state_dialect = 'standard'
def getTuStates():
    return states[state_dialect]
def getTuStatesQualifiers():
    return state_qualifiers[state_dialect]
def getStateMap():
    return state_maps[state_dialect]

#---------- Xliff 1.1 states -------------
standard_states = [
    'final',            # Indicates the terminating state.
    'needs-adaptation', #Indicates only non-textual information needs adaptation.
    'needs-l10n',       #Indicates both text and non-textual information needs adaptation.
    'needs-review-adaptation', #Indicates only non-textual information needs review.
    'needs-review-l10n',   #Indicates both text and non-textual information needs review.
    'needs-review-translation', #Indicates that only the text of the item needs to be reviewed.
    'needs-translation',    #Indicates that the item needs to be translated.
    'new',  #Indicates that the item is new. For example, translation units that were not in a previous version of the document.
    'signed-off',   #Indicates that changes are reviewed and approved.
    'translated',   #Indicates that the item has been translated.
    ]

#Target state-qualifier attr predifined vals
standard_state_qualifiers = [
    'exact-match', #Indicates an exact match. An exact match occurs when a source text of a segment is exactly the same as the source text of a segment that was translated previously.
    'fuzzy-match', #Indicates a fuzzy match. A fuzzy match occurs when a source text of a segment is very similar to the source text of a segment that was translated previously (e.g. when the difference is casing, a few changed words, white-space discripancy, etc.).
    'id-match', #Indicates a match based on matching IDs (in addition to matching text).
    'leveraged-glossary', #Indicates a translation derived from a glossary.
    'leveraged-inherited', #Indicates a translation derived from existing translation.
    'leveraged-mt', #Indicates a translation derived from machine translation.
    'leveraged-repository', #Indicates a translation derived from a translation repository.
    'leveraged-tm', #Indicates a translation derived from a translation memory.
    'mt-suggestion', #Indicates the translation is suggested by machine translation.
    'rejected-grammar', #Indicates that the item has been rejected because of incorrect grammar.
    'rejected-inaccurate', #Indicates that the item has been rejected because it is incorrect.
    'rejected-length', #Indicates that the item has been rejected because it is too long or too short.
    'rejected-spelling', #Indicates that the item has been rejected because of incorrect spelling.
    'tm-suggestion', #Indicates the translation is suggested by translation memory.
    ]


standard_map = {}
for state in standard_states:
    standard_map[state] = [state,]


#------- Suntrans -------------
suntrans_states = ['user:approved','100-Match:approved','fuzzy:approved','user:translated','100-Match:translated','fuzzy:translated','auto-translated:translated','non-translated:translated']
suntrans_state_qualifiers = []

suntrans_map = standard_map.copy()
suntrans_map['translated'] = ['user:translated','100-Match:translated','fuzzy:translated','auto-translated:translated','non-translated:translated']
suntrans_map[None] = 'needs-translation'
suntrans_map['signed-off'] = ['user:approved','100-Match:approved','fuzzy:approved','non-translated:approved']

#------- dicts that maps to dialect ------------
state_maps = {'standard':standard_map,'suntrans':suntrans_map}
states = {'standard':standard_states,'suntrans':suntrans_states}
state_qualifiers = {'standard':standard_state_qualifiers,'suntrans':suntrans_state_qualifiers}

