import gtk

class BaseTextBuffer(gtk.TextBuffer):
    'extend TextBuffer with some convenience methods'
    def __init__(self,*args,**kwargs):
        gtk.TextBuffer.__init__(self,*args,**kwargs)

    def getSelection(self):
        start = self.get_iter_at_mark(self.get_insert()).get_offset()
        end = self.get_iter_at_mark(self.get_selection_bound()).get_offset()
        # order them
        start,end = min(start,end),max(start,end)
        return start,end

    def setSelection(self,s,e):
        self.select_range(self.get_iter_at_offset(s), self.get_iter_at_offset(e))
    
    def getInsertionPoint(self):
        return self.get_iter_at_mark(self.get_insert()).get_offset()

    def setInsertionPoint(self,i):
        self.place_cursor(self.get_iter_at_offset(i))

    def setInsertionPointEnd(self):
        self.place_cursor(self.get_end_iter())

    def getText(self,s,e):
        return self.get_text(self.get_iter_at_offset(s), self.get_iter_at_offset(e))

    def clear(self):
        start,end = self.get_bounds()
        self.delete(start, end)
