__doc__ = "support for cut & paste of xml nodelist"

import gtk
from transolution.xmlutils import toxml,parseString

_gtk_clipboard = gtk.Clipboard()

class Clipboard(object):
    def __init__(self):
        self.nodelist = None
        self.text = None

    def setClipBoardNodeList(self,nodelist,text):
        """
        Copies a text to gtk clipboard and save xml nodelist.
        """
        # our internal clipboard. not shared as I could not figure out how to
        # store multiple formats using gtk clipboard :-(
        self.nodelist = nodelist
        self.text = text
        # The real clipboard
        _gtk_clipboard.set_text(text)

    def getClipBoardNodeList(self,document):
        """
        get data from clipboard as a node list.
        """
        text = _gtk_clipboard.wait_for_text()
        text = text.decode('utf-8')
        # If the nodelist we copied before had the same text we can probably use the nodelist we saved.
        if self.text == text:
            nodelist = self.nodelist
        else:
            # convert the text to a nodelist
            top_element = document.createDocumentFragment()
            top_element.appendChild(top_element.ownerDocument.createTextNode(text))
            nodelist = top_element.childNodes
        return text,nodelist

    def getText(self):
        """
        get data from clipboard as text.
        """
        text = _gtk_clipboard.wait_for_text()
        try:
            return text.decode('utf-8')
        except AttributeError,e:
            return None


try:
    clipboard
except NameError,e:
    clipboard = Clipboard()
