InterfaceErr =  NotImplementedError('must be implemented in subclasses')
class ModelInterface(object):
    'The interface to the model'

    def isLocked(self,n):
        'return True if a node is locked, False if not'
        raise InterfaceErr
    
    def getNode(self,n):
        'proxy to get a node so you can get it by index or just return it if its an excisting node to beging with'
        raise InterfaceErr

    def setFormatter(self,formatter):
        raise InterfaceErr
    
    def getNodeByTextIndex(self,str_i):
        '''
        return a tuple (node_index,sub_index_of_that_node)
        '''
        raise InterfaceErr

    def getTextSpanOfNode(self,node):
        '''
        return a tuple (start_text_index,end_text_index)
        '''
        raise InterfaceErr

    
    def pasteNodesAtTextIndex(self,ti,nodelist):
        'copy nodes in range'
        raise InterfaceErr


    def cutNodesByTextIndex(self,start,end):
        'cut nodes in range'
        raise InterfaceErr

    def copyNodesByTextIndex(self,start,end):
        'copy nodes in range'
        raise InterfaceErr
       

    def insertText(self,ti,text):
        'Insert text in a node'
        raise InterfaceErr

    def deleteText(self,start_ti,end_ti=None):
        raise InterfaceErr

    def getLast(self):
        raise InterfaceErr

    def __str__(self):
        raise InterfaceErr
    
    def __len__(self):
        raise InterfaceErr

    def getFormatted(self):
        'get a list of tupels with the (style,text)'
        raise InterfaceErr
