'This filter adds sub tus to existing xliff files.'
from formatters import FullFormatter,MinimalFormatter,MinimalExternalFormatter,NewLineExternalFormatter
from xliffparser_ng import XliffDocument,XliffException
from xliffsegment import XliffError,Model #TODO: Model name is to generic
from document.segments import TuSegment,External
from transolution.xmlutils import XmlError,getNodeAttr,setNodeAttr,setCreateNodeAttr,removeNodeAttr,getNodes,getElementsByTagName

import re
re_seg =  re.compile(r'([\.\!\?])(?=\s|$)')
re_startws =  re.compile(r'(^\s)')
def segmentate(text):
    start = 0
    max = len(text)
    while start < max:
        m = re_seg.search(text, start)
        if not m: break
        yield m
        start = m.end()

def segmentateTest():
    test_text ='This is the first seg. This is the second seg. third seg'
    start = 0
    for m in segmentate(test_text):
        print test_text[start:m.end()]
        start = m.end()

if __name__ == "__main__":

    formatter = FullFormatter()
    #formatter = MinimalFormatter()
##    formatter.setStyles(sText,sTag,sSub)
    model = Model(None,formatter,protect_tags=False)

    import sys
    xml,outfile = sys.argv[1:]
    xliff = XliffDocument(xml)
    try:
        xliff.files[0].parseSkeleton()
    except XliffException,e:
        print e
    xliff.parse()
    doc = xliff.xliffdoc
    for seg in xliff.files[0].generateSegments():
        if seg.__class__ is TuSegment:
            rootnode = seg.tu.getSourceNode()
            model.setRootNode(rootnode)
            text =  unicode(model)
            nodelists = []
            start = 0
            #TODO: beginning and ending whitespaces are included in sub TU's
            #      should be between.
##            matches = list(segmentate(text.strip()))
            matches = list(segmentate(text))
            # Only add sub tus if needed.
            if len(matches) >1:
                for m in matches:
                    nodelist = model.copyNodesByTextIndex(start,m.end())
                    nodelists.append(nodelist)
                    start = m.end()

##                nodelist = model.copyNodesByTextIndex(start,len(model))
##                nodelists.append(nodelist)
                #Why does not this work to clear source node?
    ##            for node in rootnode.childNodes:
    ##                rootnode.removeChild(node)
                
                model.clear()
                for i,nodelist in enumerate(nodelists):
                    segnode = doc.createElementNS('transolution','transolution:tu')
                    setCreateNodeAttr(segnode,'id',str(i+1))
                    for n in nodelist:
                        segnode.appendChild(n.cloneNode(True))
                    model.rootnode.appendChild(segnode)


    xliff.saveAs(outfile)   

