__doc__ = 'DOM implementation agnostic loading and & serialization'

#--------------------------------------------
# dom implementation agnostic loading and & serialization
USE_CDOMLETTE = True
try:
    if not USE_CDOMLETTE: raise ImportError('Not using CDOMLETTE')
    from Ft.Xml.Domlette import NoExtDtdReader as dom_parser, Print,PrettyPrint, implementation as dom_impl
    from Ft.Xml import EMPTY_NAMESPACE,XML_NAMESPACE
    dom_name = "4Suite Domlette"
except ImportError ,e:
    from xml.dom import minidom as dom_parser
    from xml.dom.minidom import getDOMImplementation
    from xml.dom import EMPTY_NAMESPACE,XML_NAMESPACE
    dom_impl = getDOMImplementation()
    dom_name = "Minidom"


def createDocument(name,ns=EMPTY_NAMESPACE,publicId=None,systemId=None):
    if dom_name == "4Suite Domlette":
        xmldoc = dom_impl.createDocument(ns, name, None)
        xmldoc.publicId = publicId
        xmldoc.systemId = systemId
    else:
        xmldoctype  = dom_impl.createDocumentType(name, publicId, systemId)
        xmldoc      = dom_impl.createDocument(ns, name, xmldoctype)
    return xmldoc

def loadXml(fname,uri='urn:bogus:dummy'):
    try:
        # 4Suite's Domlettes
        if hasattr(fname,'read'):
            xmldoc = dom_parser.parseStream(fname,uri)
        else:
            xmldoc = dom_parser.parseStream(file(fname),uri)
    except AttributeError,e:
        # minidom
        xmldoc = dom_parser.parse(fname)
        xmldoc.normalize()

    return xmldoc

def parseString(s,uri='urn:bogus:dummy'):
    if dom_name == "4Suite Domlette":
        if (type(s) is unicode):
            s = s.encode('utf-8')
        return dom_parser.parseString(s,uri)
    else:
        return dom_parser.parseString(s)

def toxml(node,stream=None,enc='utf-8',addheader=False):
    'dom implementation agnostic serialization, if no stream it returns a string'
    if stream is None:
        from StringIO import StringIO
        out_stream = StringIO()
    else:
        out_stream = stream

    if addheader:
        # add a xml header
        out_stream.write(unicode('<?xml version="1.0" ?>\n').encode(enc))
    
    try: out_stream.write(node.toxml(enc))
    except AttributeError,e:
        # cdomlette
        Print(node,stream=out_stream,encoding=enc)
        # minidom has problem with stripping tabs from textnode if we use this
        #PrettyPrint(node,stream=out_stream,encoding=enc)

    if not stream:
        return out_stream.getvalue()#.decode(enc)
    else:
        return out_stream
