__doc__ = 'DOM Convienience methods'

from dom_attr_util import getNodeAttr,setNodeAttr,createNodeAttr,removeNodeAttr,setCreateNodeAttr
from dom_reader_writer import EMPTY_NAMESPACE

#--------------------------------------------
# Convienience methods

class XmlError(Exception):pass

from types import StringTypes

class NodeCreator(object):
    def __init__(self,doc):
        self.doc = doc

    def createElement(self,name,attrs={},childs=[],ns=EMPTY_NAMESPACE):
        # TEST ME
        node = self.doc.createElementNS(ns,name)
        if attrs:
            for key,val in attrs.items():
                createNodeAttr(node,key,val,ns=ns)
        if childs:
            for child in childs:
                if type(child) in StringTypes:
                    child = self.doc.createTextNode(child)
                node.appendChild(child)
        return node

def getNodes(parent,nodename,occurence='*'):
    'get the child nodes from a element node, check that occurence of nodes are correct'
    nodename = unicode(nodename)
    nodes = [ node for node in parent.childNodes if node.nodeName == nodename ]
    if occurence == '*': # 0 or more
        pass
    elif occurence == '?': # 0 or 1
        if len(nodes) > 1:
            raise XmlError('more than 1 %s found'%(nodename,))
    elif occurence == '+': # 1 or more
        if not nodes:
            raise XmlError('no %s nodes found'%(nodename,))
    elif occurence == '1': # 1
        if len(nodes) != 1:
            raise XmlError('not correct number of %s nodes found:%d'%(nodename,len(nodes)))
    else:
        raise ValueError('occurence type not supported: %s'%(occurence,))
    return nodes

def getElementsByTagName(rootnode,tagname):
    if not rootnode:
        return
    ret = []
    for node in rootnode.childNodes:
        if node.ELEMENT_NODE == node.nodeType:
            if node.tagName == tagname:
                ret.append(node)
            else:
                r = getElementsByTagName(node,tagname)
                if r: ret += r
    return ret
